Option Explicit
Dim ie
Dim ProgID

If LCase(Mid(WScript.FullName,InStrRev(WScript.FullName,"\")))="\wscript.exe" Then
  Set ie=CreateObject("InternetExplorer.Application")
  ie.Visible=True
  ie.Navigate "about:blank"
  Do While ie.Busy Or ie.ReadyState<>4
    WScript.Sleep 100
  Loop
End If

For Each ProgID In WScript.Arguments
  ObjectInfo CreateObject(ProgID)
Next
If WScript.Arguments.Count Then WScript.Quit

Do
  ProgID=InputBox("Enter ProgID")
  If ProgID="" Then Exit Do
  ObjectInfo CreateObject(ProgID)
Loop
WScript.Quit

Sub ObjectInfo(Object)
Dim TLIApplication
Dim InterfaceInfo
Dim TypeLibInfo
Dim CoClassInfo

Set TLIApplication=CreateObject("TLI.TLIApplication")
Set InterfaceInfo=TLIApplication.InterfaceInfoFromObject(Object)
Set TypeLibInfo=InterfaceInfo.Parent
WriteLine "Library "&TypeLibInfo.Name
WriteLine vbTab&TypeLibInfo.HelpString
WriteLine vbTab&TypeLibInfo.ContainingFile
WriteLine ""

For Each CoClassInfo In TypeLibInfo.CoClasses
  WriteLine "Class "&CoClassInfo.Name
  WriteLine vbTab&CoClassInfo.HelpString
  WriteLine ""
  For Each InterfaceInfo In CoClassInfo.Interfaces
    WriteLine "Interface "&InterfaceInfo
    WriteLine vbTab&InterfaceInfo.HelpString
    WriteLine ""
    Call Members(InterfaceInfo)
  Next
Next
End Sub

Sub Members(InterfaceInfo)
Dim Member
Dim InvokeKind
Dim ReturnType
Dim k
Dim Parameter
Dim VarType
Dim Line

For Each Member In InterfaceInfo.Members
  Select Case Member.InvokeKind
  Case  0 InvokeKind="Unknown"
  Case  1 InvokeKind="Function"
  Case  2 InvokeKind="Property Get"
  Case  4 InvokeKind="Property Put"
  Case  8 InvokeKind="Property Let"
  Case 16 InvokeKind="Event"
  Case 32 InvokeKind="Const"
  End Select
  If Not IsEmpty(Member.ReturnType.TypedVariant) Then
    ReturnType=TypeName(Member.ReturnType.TypedVariant)
  ElseIf Member.ReturnType.TypeInfo Is Nothing Then
    ReturnType=""
    InvokeKind="Sub"
  Else
    ReturnType=Member.ReturnType.TypeInfo.Name
  End If
  Line=InvokeKind & Space(1) & Member
  Line=Line & "("
  For k=1 To Member.Parameters.Count
    Set Parameter=Member.Parameters.Item(k)
    If k>1 Then Line=Line & ", "
    If Parameter.Optional Then Line=Line & "Optional "
    Line=Line & Parameter
    If Not Parameter.VarTypeInfo.TypeInfo Is Nothing Then
      VarType=Parameter.VarTypeInfo.TypeInfo.Name
    ElseIf IsEmpty(Parameter.VarTypeInfo.TypedVariant) Then
      VarType=""
    Else
      VarType=TypeName(Parameter.VarTypeInfo.TypedVariant)
    End If
    If VarType<>"" Then Line=Line & " As " & VarType
  Next
  Line=Line & ")"
  If ReturnType<>"" Then Line=Line & " As " & ReturnType
  WriteLine Line
  WriteLine vbTab & Member.HelpString
  WriteLine ""
Next
End Sub

Sub WriteLine(Line)
If IsEmpty(ie) Then
  WScript.StdOut.WriteLine Line
Else
  ie.Document.body.insertAdjacentText "BeforeEnd",Replace(Line,vbTab,String(5,32)) & vbLf
  ie.Document.body.doScroll "down"
End If
End Sub
